package net.deliciousreya.minecraftportal.model

import net.deliciousreya.minecraftportal.extensions.toLocation
import net.deliciousreya.minecraftportal.extensions.toMaterial
import net.deliciousreya.minecraftportal.extensions.toMineralProto
import net.deliciousreya.minecraftportal.extensions.toProto
import net.deliciousreya.minecraftportal.proto.PortalSaveDataProtos
import org.bukkit.Material
import org.bukkit.Server
import java.lang.IllegalArgumentException

fun PortalSaveDataProtos.Portal.toPortal(server: Server, portalTypes: Map<Material, PortalType>): Portal {
    val portalType = portalTypes[mineral.toMaterial()] ?: throw IllegalArgumentException("No portal type for $mineral")
    val result = Portal(PortalFrame(lowerLeftFrontCorner.toLocation(server), entranceDirection.toDirection()), portalType)
    // TODO: assert that the saved portal and mineral match the actual state of the world
    return result
}

class Portal(val frame: PortalFrame, val type: PortalType) {
    fun toProto(): PortalSaveDataProtos.Portal {
        return PortalSaveDataProtos.Portal.newBuilder()
            .setLowerLeftFrontCorner(frame.lowerLeftFrontCorner.toProto())
            .setEntranceDirection(frame.direction.toProto())
            .setMineral(frame.mineral.toMineralProto())
            .build()
    }
}